//JOGO - DANIEL FERREIRA RODRIGUES - No USP 6450894

//INÍCIO DO CÓDIGO COM AS VARIÁVEIS
PImage b; //variaveis para carregar as imagens (background, nave e cometa)
PImage n;
PImage c;
PImage n2;
PFont font; //variavel para carregar a fonte
int backY = 0; //variaveis do background
int velback = 4;
int velKey = 3; //velocidade no clique do teclado
int velnaveHor = 0; //variaveis da nave
int naveY = 500;
int naveX = 200;
float nSizeX = 50;//declarações do tamanho da imagem da nave
float nSizeY = 90; 
int comX0 = int(random(20,380)); //variaveis de posicao X dos cometas
int comX1 = int(random(20,100));
int comX2 = int(random(100,200));
int comX3 = int(random(200,300));
int comX4 = int(random(300,380));
int velmin = 10; //variaveis de velocidade dos cometas
int velmax = 16;
int velcomY0 = int(random(velmin,velmax));
int velcomY1 = int(random(velmin,velmax));
int velcomY2 = int(random(velmin,velmax));
int velcomY3 = int(random(velmin,velmax));
int velcomY4 = int(random(velmin,velmax));
int comY0 = 0; //variaveis de posicao Y inicial dos cometas
int comY1 = int(random(-200,-300));
int comY2 = int(random(-400,-600));
int comY3 = int(random(-600,-800));
int comY4 = int(random(-800,-1000));
int pontos = 0; //variavel de contagem de pontos
int pontosInc = 5;//variavel que define a velocidade da contagem de pontos
int transpFill = 255;//variavel usada no game over

void setup(){ //definições gerais do jogo, chamadas somente uma vez
  size (600, 600); //tamanho da tela
  background (0); //cor do background
  b = loadImage ("background.jpg"); //as imagens são carregadas junto a suas variaveis
  n = loadImage ("nave.gif");
  c = loadImage ("cometa.gif");
  n2 = loadImage ("nave 2.gif");
  font = loadFont("BankGothicBT-Light-48.vlw"); //a fonte é carregada
  smooth();// melhora a definição
}

void draw() {  
  //DECLARAÇÕES DO BACKGROUND
  imageMode(CORNERS);
  tint(255,255,255,80); //aplica transparencia na imagem
  image(b,0,backY); //imagem 1 do background
  image(b,0,backY-600); //imagem 2 do background = copia
  backY=backY+velback;
  if (backY==+600){ //uma imagem anda atrás da outra, fazendo um ciclo de background infinito
    backY=backY-600;}
  //FINAL DAS DECLARAÇÕES DO BACKGROUND

  //DECLARACOES DO TECLADO
  if(keyPressed){
    if(keyCode == RIGHT){ //codigos da velocidade para a direita e para a esquerda
      velnaveHor = velKey;}
    if(keyCode == LEFT){
      velnaveHor = -velKey;}}
  //FINAL DAS DECLARACOES DO TECLADO

  //DECLARAÇÕES DA NAVE
  if (naveX > 375){ //impedem a nave de sair para os lados da tela
    velnaveHor = -velnaveHor;}
  if (naveX < 25){
    velnaveHor = -velnaveHor;}
  imageMode(CENTER);
  tint(255,255,255,255); //tira a transparencia na imagem
  naveX = naveX + velnaveHor; //velocidade da nave
  image(n,naveX,naveY,nSizeX,nSizeY); //chama imagem da nave   
  //FINAL DAS DECLARAÇÕES DA NAVE 

  //DECLARAÇÕES DOS COMETAS
  float comSizeX = random(30,40);//declarações do tamanho da imagem
  float comSizeY = random(80,90);  
  comY0 = comY0 + velcomY0; //velocidades dos cometas
  comY1 = comY1 + velcomY1; 
  comY2 = comY2 + velcomY2; 
  comY3 = comY3 + velcomY3; 
  comY4 = comY4 + velcomY4;
  image(c,comX0,comY0,comSizeX,comSizeY); //chamam imagem dos cometas
  image(c,comX1,comY1,comSizeX,comSizeY);
  image(c,comX2,comY2,comSizeX,comSizeY);
  image(c,comX3,comY3,comSizeX,comSizeY);
  image(c,comX4,comY4,comSizeX,comSizeY);
  //reiniciam a queda dos cometas com novos valores de X e de velocidade
  if (comY0 > 690){
    comY0 = -90;
    comX0 = int(random(20,380));
    velcomY0 = int(random(velmin,velmax));  
  }
  if (comY1 > 690){
    comY1 = -90;
    comX1 = int(random(20,380));
    velcomY1 = int(random(velmin,velmax));  
  }
  if (comY2 > 690){
    comY2 = -90;
    comX2 = int(random(20,380));
    velcomY2 = int(random(velmin,velmax)); 
  }
  if (comY3 > 690){
    comY3 = -90;
    comX3 = int(random(20,380));
    velcomY3 = int(random(velmin,velmax));  
  }
  if (comY4 > 690){
    comY4 = -400;
    comX4 = int(random(20,380));
    velcomY4 = int(random(velmin,velmax)); 
  }
  //FINAL DAS DECLARAÇÕES DOS COMETAS

  //DECLARACOES DE INTERACAO
  int dCentros0 = int(dist(comX0,comY0,naveX,naveY-50)); //definimos a variavel como a distância entre os centros definidos da nave e do cometa
  int dCentros1 = int(dist(comX1,comY1,naveX,naveY-50));
  int dCentros2 = int(dist(comX2,comY2,naveX,naveY-50));
  int dCentros3 = int(dist(comX3,comY3,naveX,naveY-50));
  int dCentros4 = int(dist(comX4,comY4,naveX,naveY-50));
//se a distancia for menor ou igual a 40 é detectada a colisão, ativando a função GameOver
  if (dCentros0 <= 40 || dCentros1 <= 40 || dCentros2 <= 40 || dCentros3 <= 40 || dCentros4 <= 40){ 
    GameOver();
  }
  //FINAL DAS DECLARACOES DE INTERACAO

  //CONTAGEM DE PONTOS
  stroke(255);//desenho da área lateral
  fill(0);
  quad(400, 0, 400, 600, 600, 600, 600, 0);
  line(400,90,600,90);
  if (comY0 < 1000){ //é definida a contagem infinita de pontos, já que este valor nunca será alcançado
    pontos = pontos + pontosInc;} //definido o incremento na variavel
  fill(255); //entram textos
  textFont(font, 32);
  textAlign(CENTER);
  text("Starship", 500, 40);
  text("Trooper", 500, 70);
  textSize(24);
  text("Pontos", 500, 270);
  textSize(50);
  text(pontos, 500, 320);
  if (n == n2){ //se a igualdade que está presente no game over acontecer, é ativado este texto, mantido dentro de draw
    textFont(font, 120);
    textAlign(CENTER);
    text("Game", 200, 220);
    textFont(font, 128);
    text("Over", 200, 310);
  }
  delay (8); //tempo entre os frames
}
//FINAL DA FUNÇAO DRAW

void keyReleased(){ //se a tecla é solta, zera a velocidade  
  velnaveHor = 0;
}

void GameOver(){ //Função de Game Over
  velback = 1; //diminui todas as velocidades
  velmax = 3;
  velmin = 3;
  velcomY0 = 3;
  velcomY1 = 3;
  velcomY2 = 3;
  velcomY3 = 3;
  velcomY4 = 3;    
  fill(255,255,255,transpFill); //surge flash branco sem transparencia
  quad (0,0,0,600,400,600,400,0);
  transpFill = transpFill-90; //transparencia ativada para que o flash não apareça mais
  n = n2; //muda a imagem para a nave destruida
  pontosInc = 0; //os pontos param de mudar
  velKey = 0; //a nave não se move mais
}

//FINAL DO CÓDIGO
